#include <Eigen/Dense>
#include <vector>

class SimpleSlam {

public:
  struct ScanPoint {
    Eigen::Vector2f point;
    Eigen::Vector2f normal;
    float normal_distance;
  };
  void calculate_normals(const std::vector<Eigen::Vector2f> &scan,
                         std::vector<ScanPoint> &normals) {
    for (unsigned int i = 0; i < scan.size(); i += 1) {
      /* TODO comapre not only prev and next but based on distance */
      const auto &prev = scan[(i - 1) % scan.size()];
      const auto &next = scan[(i + 1) % scan.size()];
      ScanPoint p;
      float dist_prev = (scan[i] - prev).squaredNorm();
      float dist_next = (scan[i] - next).squaredNorm();
      auto n = dist_next < dist_prev ? (next - scan[i]) : (prev - scan[i]);
      const Eigen::Matrix2f r{{0,1},{-1,0}};
      p.normal = r*n;
      normals.push_back(p);

    }
  };
  void process_scan(const std::vector<Eigen::Vector2f> &scan) {
    std::vector<ScanPoint> points;
    calculate_normals(scan, points);
  };
};
